﻿-- (c) eradicator a.k.a lossycrypt, 2021, not seperately licensable

-- -------------------------------------------------------------------------- --
-- Built-In                                                                   --
-- -------------------------------------------------------------------------- --
local elroot = (pcall(require,'erlib/empty')) and '' or '__eradicators-library__/'
local say,warn,err,elreq,flag,ercfg=table.unpack(require(elroot..'erlib/shared'))

-- -------------------------------------------------------------------------- --
-- Eradicators Library                                                        --
-- (Factorio does not allow runtime require!)                                 --
-- -------------------------------------------------------------------------- --
local log         = elreq('erlib/lua/Log'          )().Logger  'ER:VRAM'
-- local stop        = elreq('erlib/lua/Error'        )().Stopper 'ER:VRAM'

--------------------------------------------------------------------------------
return function(phase)

  ------------------------------------------------------------------------------
  local function elreq (path) return require('__eradicators-library__/'..path) end
  
  ------------------------------------------------------------------------------
  -- if flag.IS_DEV_MODE then
    -- _ENV. Hydra = elreq('erlib/lua/Coding/Hydra')()
    -- end
  
  ------------------------------------------------------------------------------
  -- if phase == 'settings' then
    -- Don't want to add a one-line settings file to every plugin!
    -- erlib_enable_plugin 'on_ticked_action'
    -- erlib_enable_plugin 'on_player_changed_chunk'
    -- erlib_enable_plugin 'on_user_panic'
    -- erlib_enable_plugin 'on_entity_created'
    -- end
  
  ------------------------------------------------------------------------------
  if (phase ~= 'control-updates') and (phase ~= 'control-final-fixes') then
    _ENV. PluginManager = elreq ('erlib/factorio/PluginManagerLite-1')()
    end
    
  ------------------------------------------------------------------------------
  if phase == 'control' then
    -- _ENV. EventManager  = elreq ('erlib/factorio/EventManagerLite-1')()
    -- _ENV. PluginManager.enable_savedata_management()
    
    local Lock = elreq ('erlib/lua/Lock')()
    Lock.AutoLock(_ENV, '_ENV')
    
  elseif phase == 'control-updates' then
  elseif phase == 'control-final-fixes' then
    end
  
  ------------------------------------------------------------------------------
  
  local function load_phase(phase)
    
    local function wants_phase(phases)
      for i=1,#phases do
        if phases[i] == phase then return true end
        end
      end

    local plugin_array = require 'plugins/!init/load-order.lua'
      
    for i=1, #plugin_array do
      local plugin_name = plugin_array[i][1]
      local phases = plugin_array[i][2]
      if (phases.dev_only == nil) or (flag.IS_DEV_MODE) then
        if wants_phase(phases) then
          local file_path = table.concat({'plugins', plugin_name, phase},'/')
          -- say('erdacitators-tweaks is loading:' .. file_path)
          log:debug('require("',file_path,'")')
          require(file_path)
          end
        end
      end
    end
    
  load_phase(phase)
  
  ------------------------------------------------------------------------------
  if phase == 'control-final-fixes'
  and remote.interfaces['__00-universal-locale__/remote'] then
    load_phase('ulocale')
    end

  ------------------------------------------------------------------------------
  if not phase:find 'control' then
    _ENV. PluginManager = nil -- clean up after use
    end
  
  ------------------------------------------------------------------------------
  end