﻿local _ = '__00-universal-locale__/remote' if remote.interfaces[_] then

local import = PluginManager.make_relative_require 'animation-downsampler'
local const  = import '/const'

-- -------------------------------------------------------------------------- --
require(_)('animation-downsampler', {

  ['[mod-setting-name]'] = {
    [const.name.setting.lq_vram_percentage] = { 
      en = "Normal Resolution Sprite VRAM Usage (%)",
      -- de = "",
      -- ja = "",
      },
    [const.name.setting.hq_vram_percentage] = { 
      en = "High Resolution Sprite VRAM Usage (%)",
      -- de = "",
      -- ja = "",
      },    
    [const.name.setting.min_frames_to_keep] = { 
      en = "_UL:PowerUserSetting_ Animation Minimum Frame Count",
      -- de = "",
      -- ja = "",
      },
    },
    
  ['[mod-setting-description]'] = {
    [const.name.setting.lq_vram_percentage] = { 
      en = "0%: Disables all animations.\n "
        .. "25%: Removes 75% of all animation frames .\n "
        .. "100%: Disables VRAM saving for this sprite resolution."
        ,
      -- de = "",
      -- ja = "",
      },
    [const.name.setting.hq_vram_percentage] = { 
      en = "↑ See also Normal Resolution.\n"
        .. '_UL:1SPACE_\n'
        .. 'Your graphics setting for "Sprite resolution" '
        .. "determines which value is used for factorio sprites. "
        .. "Mods that do not support high resolution will always "
        .. "use the normal resolution setting. "
        ,
      de = "",
      ja = "",
      },    
    [const.name.setting.min_frames_to_keep] = { 
      en = "Prevents the factory from looking completely frozen "
        .. 'when using very low "VRAM Usage" percentages. '
        ,
      -- de = "",
      -- ja = "",
      },
    },


  }) end